#!/bin/bash

. ./.jprojects.sh || exit 255

for DIST in ${LIST}; do
	echo "$0: Executing '${DIST}' ..."
	P=${DIST%/*}

	echo "$0: P='${P}'"
	cd "${JPROJECTS_HOME}/${P}" || exit 255

	if [ ! -e "build.xml" ]
	then
		echo "$0: No build.xml found, skipping project '${P}'."
		continue
	fi

	if [ "$1" != "d" ]
	then
		# Cleanup project and build JAR
		ant clean jar

		# Save status
		STATUS="$?"

		# Has it failed?
		if [ "${STATUS}" != "0" ]
		then
			# This has failed, so try "dist"
			ant clean dist
			STATUS="$?"

			# Still failing? Oh, to bad
			if [ "${STATUS}" != "0" ]
			then
				echo "$0: Failed to build '${DIST}'."
				exit 1
			fi
		fi
	fi

	if [ ! -f "./dist.sh" ]
	then
		echo "$0: Project '${DIST}' has no dist.sh"
	elif [ ! -e "./dist.sh" ]
	then
		echo "$0: Error: Project '${DIST}' has non-executable dist.sh!"
		exit 1
	else
		./dist.sh
	fi
done

echo "$0: All done."
exit 0
